Bug 406151 - 3.5: Additional Red Hat specific whiteboard bug fields.whiteboards (qa,devel,internal) and the access restrictions for those.
3.5: Additional Red Hat specific whiteboard bug fields.whiteboards (qa,devel,...
Status: CLOSED NEXTRELEASE
Product: Bugzilla
Classification: Community
Component: Bugzilla General (Show other bugs)
3.2
All Linux
high Severity medium (vote)
: ---
: ---
Assigned To: David Lawrence
:
Depends On:
Blocks: RHBZ30UpgradeTracker 427051 427052
  Show dependency treegraph
 
Reported: 2007-11-30 11:58 EST by David Lawrence
Modified: 2013-06-24 00:19 EDT (History)
0 users

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2008-03-05 17:30:58 EST
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---


Attachments (Terms of Use)
Patch to add devel,qa,internal, and fixed in whiteboard fields (v1) (477 bytes, patch)
2008-02-07 15:23 EST, David Lawrence
dkl: review-
Details | Diff
Patch to add devel,qa,internal, and fixed in whiteboard fields (v1) (22.20 KB, patch)
2008-02-07 16:11 EST, David Lawrence
dkl: review-
dkl: review-
Details | Diff
Patch to add devel,qa,internal, and fixed in whiteboard fields (v2) (32.84 KB, patch)
2008-02-12 17:20 EST, David Lawrence
nelhawar: review-
Details | Diff
Patch to add devel,qa,internal, and fixed in whiteboard fields (v3) (33.48 KB, patch)
2008-02-13 00:02 EST, David Lawrence
nelhawar: review+
Details | Diff

  None (edit)
Description David Lawrence 2007-11-30 11:58:01 EST
Description:
Red Hat has added several special purpose whiteboard fields that must be functional in the new system. The new whiteboards include qa_whiteboard, devel_whiteboard, and internal_whiteboard. The whiteboards must be private to their relevant Bugzilla permissions groups.

Function Requirements:
The additional fields must be present in the database schema as well as in all of the templates and cgi's where whiteboards are allowed to be viewed and edited.
Comment 1 Tony Fu 2007-12-19 01:37:26 EST
Size Estimation:

This function is implemented in rh_bugzilla_2_18 by using  !::UserInGroup('...')
function in relevant scripts.  There are about 6 scirpts used this mechanism in
rh_bugzilla_2_18 and every script use this function 5 times in average.  So I
assurm that there are similar amount usage in rh_bugzilla_3.0.

Based on a historical method, the LOC will be
6*5*3 = 90 (here, assume calling this function needs three lines, like
if (!::UserInGroup('...') 
{.....}
else {...}

Test unit:
Can use Selenium to test it.  Based on previous Selenium test set, the LOC will
be 20 lines

Total LOC = 90+20=110
Comment 2 David Lawrence 2008-02-07 15:19:17 EST
Attaching patch for this feature. Devel, QA, and Internal whiteboards are
visible, protected, and editable. Also add the fixed in field below the close
bug section of the knob.

Please review

Dave
Comment 3 David Lawrence 2008-02-07 15:23:46 EST
Created attachment 294263 [details]
Patch to add devel,qa,internal, and fixed in whiteboard fields (v1)
Comment 4 David Lawrence 2008-02-07 16:11:03 EST
Created attachment 294269 [details]
Patch to add devel,qa,internal, and fixed in whiteboard fields (v1)

Bad Dave, Bad. Attached a bogus file instead of the right patch. Here's the
right one.
Comment 5 David Lawrence 2008-02-12 17:20:39 EST
Created attachment 294706 [details]
Patch to add devel,qa,internal, and fixed in whiteboard fields (v2)

Added whiteboard support to enter_bug.cgi. Added #REDHAT comments in the
appropriate places.

Noura, colchange.cgi seems to work properly for me. Not sure why you are
getting the HTML page instead of the revised results list.

Please review this new patch.

Dave
Comment 6 Noura El hawary 2008-02-12 23:33:22 EST
Hi Dave,

I took a look at your patch and tested it , basically i had to do 2 things to be
able to use it:
1- add the extra whiteboard fields and fixed in to the bugs table
2- add the column definitions to the fielddefs table.

The patch looks good and was functioning properly only 2 thoughts:
1- with the internal_whiteboard I don't see that we have this field displayed in
enter_bug.cgi in our 2.18 , so shall it be the same for 3.2 this means changes
to enter_bug.cgi , tenplate bug/create/create and also post_bug.cgi.

2- also for colchange.cgi in 2.18 we don't have either fixed_in or
internal_whiteboard shall it be the same in 3.2?

3- and last thing I noticed is that for example:
  - user in devel group change the column list of a buglist to include
devel_whiteboard then they logout.
  - another user logs in that is not in devel group and they view some buglist
they still can see the devel_whiteboard column and its values although they are
not permitted to.

other than that it looks good :)

Noura
Comment 7 David Lawrence 2008-02-12 23:49:19 EST
(In reply to comment #6)
> Hi Dave,
> 
> I took a look at your patch and tested it , basically i had to do 2 things to be
> able to use it:
> 1- add the extra whiteboard fields and fixed in to the bugs table
> 2- add the column definitions to the fielddefs table.

One thing to keep in mind is that we will be doing an upgrade of our 2.18
database instead of creating a stock 3.2 one from scratch and then importing.
This means that the extra columns in the bugs table will already be present.
As well for the fielddefs values.

> 
> The patch looks good and was functioning properly only 2 thoughts:
> 1- with the internal_whiteboard I don't see that we have this field displayed in
> enter_bug.cgi in our 2.18 , so shall it be the same for 3.2 this means changes
> to enter_bug.cgi , tenplate bug/create/create and also post_bug.cgi.

internal_whiteboard currently is mostly used by hardware catalog for storing
extran information. It may be useful for other purposes as well so I added it
in. We should see what the users think and ask for feedback.

> 2- also for colchange.cgi in 2.18 we don't have either fixed_in or
> internal_whiteboard shall it be the same in 3.2?

Same comment as above for internal_whiteboard. Also people will probably want to
see fixed in as a column so this should have been in 2.18 but somehow fell
through the cracks.

> 3- and last thing I noticed is that for example:
>   - user in devel group change the column list of a buglist to include
> devel_whiteboard then they logout.
>   - another user logs in that is not in devel group and they view some buglist
> they still can see the devel_whiteboard column and its values although they are
> not permitted to.

Ok, will add code to buglist.cgi to do another check for permission and remove
the relevant values from @selectcolumns before running the query if the user
does not have proper permissions.

Dave
Comment 8 David Lawrence 2008-02-13 00:02:30 EST
Created attachment 294730 [details]
Patch to add devel,qa,internal, and fixed in whiteboard fields (v3)

New patch that removes the private whiteboards from the column list in
buglist.cgi 
if user is not in proper groups.

Please take a look
Thanks
Dave
Comment 9 Noura El hawary 2008-02-13 00:17:17 EST
Comment on attachment 294730 [details]
Patch to add devel,qa,internal, and fixed in whiteboard fields (v3)

Hi Dave,

now buglist.cgi is functioning properly :), I think the patch looks good to go.

Noura
Comment 10 David Lawrence 2008-03-05 17:31:36 EST
Worked 4 additional hours.

Note You need to log in before you can comment on or make changes to this bug.